<template>
  <div class="wrap">
    <div class="items">
      <item v-for="item in items" v-bind:data="item" v-bind:edit="item.edit"
            v-bind:on-create="registerItem" v-bind:on-remove="deregisterItem"
            v-on:disableEdit="disableEdit"></item>
    </div>

    <div class="no-items" v-if="!items.length">
      No need for shopping today!
    </div>
  </div>
</template>

<script>
import ListService from '../list-service';
import Item from './Item';

const itemComponents = [];

export default {
  name: 'item-list',
  components: {
    Item
  },
  data() {
    return {
      items: ListService.items
    };
  },
  methods: {
    registerItem(item) {
      itemComponents.push(item);
    },
    deregisterItem(item) {
      const idx = itemComponents.indexOf(item);

      if (idx !== -1) {
        itemComponents.splice(idx, 1);
      }
    },
    disableEdit() {
      itemComponents.forEach((component) => {
        component.editMode = false;
      });
    }
  }
};
</script>

<style scoped lang="scss">
.wrap {
  display: flex;
  flex-flow: column nowrap;
  align-items: center;
  overflow: auto;
  flex: 1;

  @media(max-width: 600px) {
    max-width: auto;
  }
}

.items {
  max-width: 900px;
  width: 100%;
  box-shadow: 0 0 30px rgba(#000, 0.3);
}

.no-items {
  padding: 40px;
  color: #ccc;
  font-size: 24px;
  text-align: center;
}
</style>
